"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pagination = void 0;
const common_1 = require("@nestjs/common");
const load_package_util_1 = require("@nestjs/common/utils/load-package.util");
exports.Pagination = (0, common_1.createParamDecorator)((data, ctx) => {
    const request = ctx.switchToHttp().getRequest();
    return {
        limit: request.query.limit
            ? parseInt(request.query.limit)
            : (data === null || data === void 0 ? void 0 : data.limit) || undefined,
        page: request.query.page ? parseInt(request.query.page) : (data === null || data === void 0 ? void 0 : data.page) || 0,
        orderDirection: request.query.orderDirection || data.orderDirection || null,
        orderBy: request.query.orderBy || data.orderBy || null,
        searchKey: request.query.searchKey || null,
    };
}, [
    (target, key) => {
        const Swagger = (0, load_package_util_1.loadPackage)('@nestjs/swagger', 'PaginationDecorator', () => require('@nestjs/swagger'));
        if (Swagger) {
            Swagger.ApiQuery({
                name: 'page',
                schema: {
                    type: 'number',
                    description: 'The page to start pagination, zero-based indexing',
                },
                required: false,
            })(target, key, Object.getOwnPropertyDescriptor(target, key));
            Swagger.ApiQuery({
                name: 'limit',
                schema: {
                    type: 'number',
                    description: 'The limit, numbers of rows returnded',
                },
                required: false,
            })(target, key, Object.getOwnPropertyDescriptor(target, key));
            Swagger.ApiQuery({
                name: 'orderBy',
                schema: {
                    type: 'string',
                    description: 'The OrderBy key',
                },
                required: false,
            })(target, key, Object.getOwnPropertyDescriptor(target, key));
            Swagger.ApiQuery({
                name: 'orderDirection',
                schema: {
                    type: 'string',
                    description: 'The OrderBy direction',
                },
                required: false,
            })(target, key, Object.getOwnPropertyDescriptor(target, key));
            Swagger.ApiQuery({
                name: 'searchKey',
                schema: {
                    type: 'string',
                    description: 'The search key',
                },
                required: false,
            })(target, key, Object.getOwnPropertyDescriptor(target, key));
        }
    },
]);
