"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginationService = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const sequelize_1 = require("@nestjs/sequelize");
const constants_1 = require("./constants");
const pagination_entity_1 = require("./pagination.entity");
let PaginationService = class PaginationService {
    constructor(moduleRef, defaultOptions) {
        this.moduleRef = moduleRef;
        this.defaultOptions = defaultOptions;
    }
    findAll(options, optionsSequelize) {
        return __awaiter(this, void 0, void 0, function* () {
            const repository = this.moduleRef.get((0, sequelize_1.getModelToken)(options.model), {
                strict: false,
            });
            const limit = options.limit || this.defaultOptions.limit;
            let page = options.page || this.defaultOptions.page;
            page = page ? page - 1 : 0;
            const orderBy = options.orderBy || undefined;
            const orderDirection = options.orderDirection || this.defaultOptions.orderDirection || undefined;
            const offset = page * options.limit || page * options.limit;
            const queryOptions = Object.assign({ limit,
                offset, order: orderBy ? [[orderBy, orderDirection]] : undefined }, optionsSequelize);
            const response = yield repository.findAndCountAll(Object.assign({}, queryOptions));
            return {
                data: response.rows,
                total: response.count,
                totalPages: Math.ceil(response.count / options.limit),
                limit: options.limit,
                page: options.page ? options.page : 1,
            };
        });
    }
};
PaginationService = __decorate([
    (0, common_1.Injectable)(),
    __param(1, (0, common_1.Inject)(constants_1.PAGINATION_OPTIONS)),
    __metadata("design:paramtypes", [core_1.ModuleRef,
        pagination_entity_1.PaginationQuery])
], PaginationService);
exports.PaginationService = PaginationService;
